unit fMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, cTCPServer, StdCtrls;

type
  TForm1 = class(TForm)
    fndTCPServer: TfndTCPServer;
    ClientCountLabel: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure fndTCPServerClientActive(Sender: TTCPServerClient);
    procedure fndTCPServerClientRemoved(Sender: TTCPServerClient);
    procedure fndTCPServerDataAvailable(Sender: TTCPServerClient);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure fndTCPServerLog(Sender: ATCPServer; Msg: String);
  private
    procedure RefreshClientCount;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.RefreshClientCount;
begin
  ClientCountLabel.Caption := 'Clients: ' + IntToStr(fndTCPServer.ClientCount);
end;

procedure TForm1.fndTCPServerClientActive(Sender: TTCPServerClient);
begin
  // Client count has increased
  RefreshClientCount;
end;

procedure TForm1.fndTCPServerClientRemoved(Sender: TTCPServerClient);
begin
  // Client count has decreased
  RefreshClientCount;
end;

procedure TForm1.fndTCPServerDataAvailable(Sender: TTCPServerClient);
begin
  // Send back whatever is received
  Sender.WriteStr(Sender.ReadAvailable); 
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  fndTCPServer.Active := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  fndTCPServer.Active := False;
  RefreshClientCount;
end;

procedure TForm1.fndTCPServerLog(Sender: ATCPServer; Msg: String);
begin
  Label1.Caption := Msg;
end;

end.

