unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, cTCPServer, StdCtrls;

type
  TForm1 = class(TForm)
    fndTCPServer: TfndTCPServer;
    ClientCountLabel: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure fndTCPServerThreadRun(Sender: TTCPServerClient);
    procedure fndTCPServerClientActive(Sender: TTCPServerClient);
    procedure fndTCPServerClientRemoved(Sender: TTCPServerClient);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure fndTCPServerLog(Sender: ATCPServer; Msg: String);
  private
    procedure UpdateClientCount;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.UpdateClientCount;
begin
  ClientCountLabel.Caption := 'Clients: ' + IntToStr(fndTCPServer.ClientCount);
end;

procedure TForm1.fndTCPServerThreadRun(Sender: TTCPServerClient);
var S: String;
begin
  Sender.Stream.WriteStr('Hello world. What is your name?');

  // Stream is in blocking mode for threaded clients
  S := Sender.Stream.Reader.ExtractLine;

  Sender.Stream.WriteStr('Bye ' + S + '.');
end;

procedure TForm1.fndTCPServerClientActive(Sender: TTCPServerClient);
begin
  UpdateClientCount;
end;

procedure TForm1.fndTCPServerClientRemoved(Sender: TTCPServerClient);
begin
  UpdateClientCount;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  fndTCPServer.Active := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  fndTCPServer.Active := False;
  UpdateClientCount;
end;

procedure TForm1.fndTCPServerLog(Sender: ATCPServer; Msg: String);
begin
  Label1.Caption := Msg;
end;

end.

