;NSIS Modern User Interface version 1.70

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  !define VERSION "2.9"
  !define TITLE "SunriseChat"
  !define FULL_TITLE "SunriseChat"
  !define CREATOR "Chronosoft"
  !define CHANGELOG_FILE "Novinky.txt"

  ;Name and file
  Name "${FULL_TITLE} ${VERSION}"
  OutFile "Instalace${TITLE}-${VERSION}.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\${FULL_TITLE}\"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\${CREATOR}\${FULL_TITLE}" ""

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Language Selection Dialog Settings

  ;Remember the installer language
  !define MUI_LANGDLL_REGISTRY_ROOT "HKCU" 
  !define MUI_LANGDLL_REGISTRY_KEY "Software\${CREATOR}\${FULL_TITLE}" 
  !define MUI_LANGDLL_REGISTRY_VALUENAME "Installer Language"

;--------------------------------
;Pages

  !define MUI_ICON "..\Resources\Icons\SunriseChat.ico"
  !define MUI_UNICON "..\Resources\Icons\SunriseChat.ico"
  ;!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

  !insertmacro MUI_PAGE_WELCOME
  ;!insertmacro MUI_PAGE_LICENSE "${NSISDIR}\Contrib\Modern UI\License.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES

;--------------------------------
;Languages

  !insertmacro MUI_LANGUAGE "English"
  !insertmacro MUI_LANGUAGE "Czech"

;--------------------------------
;Reserve Files
  
  ;These files should be inserted before other files in the data block
  ;Keep these lines before any File command
  ;Only for solid compression (by default, solid compression is enabled for BZIP2 and LZMA)

  !insertmacro MUI_RESERVEFILE_LANGDLL

;--------------------------------
;Installer Sections

Section "Nutn sousti" Nutne

  SectionIn RO

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${TITLE}" "DisplayName" "${FULL_TITLE}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${TITLE}" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${TITLE}" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${TITLE}" "NoRepair" 1

  SetOutPath "$INSTDIR"
  
  ;ADD YOUR OWN FILES HERE...
  File "..\_Latest\SunriseChat.exe"
  File "..\_Latest\SunriseChat.map"
  File "..\_Latest\Network.cfg"
  File "..\_Latest\Horse.avi"
  File "..\${CHANGELOG_FILE}" 
  File "..\Resources\Icons\Envelope.ico" 

  ;Language files
  File "..\_Latest\Czech.lng"
  File "..\_Latest\English.lng"

  ;Store installation folder
  WriteRegStr HKCU "Software\${CREATOR}\${TITLE}" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd

Section "Pidat do nabdky Start" 

  CreateDirectory "$SMPROGRAMS\${FULL_TITLE}"
  CreateShortCut "$SMPROGRAMS\${FULL_TITLE}\Uninstall.lnk" "$INSTDIR\uninstall.exe"
  CreateShortCut "$SMPROGRAMS\${FULL_TITLE}\${FULL_TITLE}.lnk" "$INSTDIR\${TITLE}.exe"
  CreateShortCut "$SMPROGRAMS\${FULL_TITLE}\${CHANGELOG_FILE}" "$INSTDIR\${CHANGELOG_FILE}"
  
SectionEnd

Section "Umstit ikonu na plochu" 

  CreateShortCut "$DESKTOP\${FULL_TITLE}.lnk" "$INSTDIR\${TITLE}.exe" 
  
SectionEnd

Section "Zobrazit informace" 

  ExecShell "open" "${CHANGELOG_FILE}"
  
SectionEnd

Section "Koprovat zvuky" 

  SetOutPath "$INSTDIR\Sounds"
  
  File "..\Resources\Sounds\*.*"
  
SectionEnd

Section "Koprovat obrzky" 

;  SetOutPath "$INSTDIR\Images"
  
;  File "..\Resources\Images\*.*"
  
  SetOutPath "$INSTDIR\Smileys"
  
  File /r "..\Resources\Images\Smileys\SunriseChat (sunrisechat.zdechov.net)\*.*" 

SectionEnd

;--------------------------------
;Installer Functions

Function .onInit

  !insertmacro MUI_LANGDLL_DISPLAY

FunctionEnd

;--------------------------------
;Descriptions

  ;USE A LANGUAGE STRING IF YOU WANT YOUR DESCRIPTIONS TO BE LANGAUGE SPECIFIC

  ;Assign descriptions to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${Nutne} "Vyberte potebn sousti."
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

 
;--------------------------------
;Uninstaller Section

Section "Uninstall"

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${TITLE}"
 
  Delete "$DESKTOP\${TITLE}.lnk" 

  RMDir /r "$SMPROGRAMS\${FULL_TITLE}"
  RMDir /r "$INSTDIR"


  DeleteRegKey /ifempty HKCU "Software\${CREATOR}\${FULL_TITLE}"

SectionEnd

;--------------------------------
;Uninstaller Functions

Function un.onInit

  !insertmacro MUI_UNGETLANGUAGE
  
FunctionEnd